import {
  select,
  csv,
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  scaleOrdinal,
  schemeSpectral
} from 'd3';

import { scatterplot } from './scatterplot';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {

  
  const cValue = data => data['IncomeGroup'];
  const country = data => data['Country'];
  
  const color = scaleOrdinal(schemeSpectral[4]);
  

  //console.log(color.domain)
  
 
  const margin = { top: 50, right: 40, bottom: 60, left: 100 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
  
  
  // Reference: http://bl.ocks.org/weiglemc/6185069
  // draw legend
  
  let selectedLegend;
  
  const onClick = d => {
    selectedLegend = d;
 //   console.log({selectedLegend});
    render();
  };
  
   
  const render = () => {
   svg.call(scatterplot, {
    circleRadius: 4,
    margin: { top: 50, right: 40, bottom: 60, left: 100 },
    width,
    height,
    data,
    color,
    cValue,
    selectedLegend,
    data
  });

  
    legend
      .merge(g)
        .attr('opacity', d => 
          (!selectedLegend || d === selectedLegend)
              ? 1
              : 0.2
         )
        .on('click', d => onClick(
          d === selectedLegend
          ? null
          : d
          ));
  };
  
  var legend = svg.selectAll(".legend")
      .data(color.domain())
    .enter().append("g")
      .attr("class", "legend")
      .attr("transform", (d, i) => `translate(-40,${(i + 8.5) * 20})`)
    .merge(g)
      .attr('opacity', d => 
            (!selectedLegend || d === selectedLegend)
              ? 1
              : 0.2
           )
      .on('click', d => onClick(
        d === selectedLegend
          ? null
          : d
      ));

  // draw legend colored rectangles
  legend.append("rect")
      .attr("x", width - 18)
      .attr("y", -110)
      .attr("width", 18)
      .attr("height", 18)
      .style("fill", color);

  // draw legend text
  legend.append("text")
      .attr("x", width - 24)
      .attr("y", -105)
      .attr("dy", ".6em")
      .style("text-anchor", "end")
      .text(function(d) { return d;})
};

  
csv('https://vizhub.com/veagy/datasets/3-tax-vs-high-tech-exp.csv')
  .then(data => {
    data.forEach(d => {
      d['High-technology exports (% of manufactured exports)'] = +d['High-technology exports (% of manufactured exports)'];
      d['Taxes on international trade (% of revenue)'] = +d['Taxes on international trade (% of revenue)'];
    });
    render(data);
  });